<?php
/******************************************************************************************/
/*                                 IMG2ASCII - Core Class                                 */  
/******************************************************************************************/
/*
    IMG2ASCII version 2
    
    Copyright 2004 by Ueli Weiss (uweiss_at_gmx_dot_ch)
    
    This program is free software; you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation. This program is distributed in the hope 
    that it will be useful, but WITHOUT ANY WARRANTY; without even the 
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
    See the GNU General Public License for more details.
    
    This copyright text may not be edited or deleted.
    
    Best quality is achieved with font size 13 - 20 (since there is no 
    anti-aliasing, which would make the image too light). Scaling the image 
    down afterwards in an image manipulation program leads to better results.
    
    You may use generated images on your websites, or wherever you like, but 
    if you do, please add a link to http://img2ascii.sourceforge.net as a 
    return service. Thanks!
    
    Have fun!
                                                                                          */
/******************************************************************************************/

// Connecting to Database, to edit by the user
$db_server = "localhost";
$db_name = "db";
$db_user = "username";
$db_passwort = "password";

MYSQL_CONNECT($db_server,$db_user,$db_passwort);
MYSQL_SELECT_DB($db_name);

// Include Image functions
require_once('image_color_class.php');

class img2ascii
{
  // Global Variables
  var $version;       // Version
  var $self;          // This file
  var $depth;         // Depth of character search
  var $timelimit;     // Sets the max_execution_time for the running time of this script (in seconds).
  var $htmlencoded;   // display the code correctly , for example  is &#193;
  var $type;          // type of output returned; 1 = Table, 2 = ASCII
  var $unicode;       // use ASCII only or also Unicode?
  var $where;         // where clause for mySQL query
  var $color;         // Is color used?
  var $inverse;       // Inversed color value (only in combination with color)
  var $inverter;      // use inverted color of back- and foreground (same as art containing 6)
  var $lastspan;      // used with inverter function. saves the last span, to save space. "c" or "i"
  var $inverseascii;  // Inversed ASCII lookup
  var $letter_types;  // Types of Characters, example: letters, numbers, block-like symbols
  var $chars;         // characters to use, $this->letter_types is omitted, except the inverter (6)
  var $nodispersion;  // Random dispersion of characters. if disabled, the first best will be taken.
  var $antialias;     // Every pixel will be used to determin color value. (Anti-aliasing)
  var $fontsize;      // Font size (4,6,8,13,16,20)
  var $size;          // Database for selected font
  var $write;         // Text to write, either write letter or not, depending on darkness
  var $writepts;      // Saves the amount of pixels (array) of the character of $write.
  var $towrite;       // array with what to write
  var $t;             // position in iteration for write mode
  var $writemax;      // the maximum amount of pixels/character in the string
  var $writemin;      // the minimal amount of pixels/character in the string
  var $px;            // Letter or table cell width
  var $py;            // Letter or table cell height
  var $letterspacing; // spacing width of the output
  var $lignheight;    // spacing height of the output
  var $fh;            // flip horizontally
  var $fv;            // flip vertically
  var $opening_tag;   // Tag over the whole text, opening
  var $closing_tag;   // Tag over the whole text, closing
  var $newline_tag;   // Tag at the beginning of each line
  var $endline_tag;   // Tag at the end of each line
  var $color_background;// Background     (needed for inverter function)
  var $color_font;    // main font color  (needed for inverter function)
  var $color_font2;   // if a second color is used (this function should only be used with a
                      // medium colored background, and lighter/darker other fonts)
  var $p_two_colored; // percentage for the second color 0 <= p <= 1
  var $median;        // for 2-color mode, somewhere between $black and $white
  var $lastfontcolor; // similar to last_span. saves which font tag for the 2-color mode was used "w" or "b"
  var $output_ok;     // was the output generated correctly? 1 for ok.
	var $styletag;			// is the style tag displayed? default = 1, only with animation its not needed anymore
  
  // constructor, initialization of default values
  function img2ascii()
  {
    $this->version = "2.0";
    $this->self = substr($_SERVER["PHP_SELF"],strrpos($_SERVER["PHP_SELF"],"/")+1);
    $this->depth = 5;
    $this->timelimit = 1000;	
    set_time_limit($this->timelimit);
    $this->htmlencoded = 0;
    $this->set_type(2);
    $this->unicode = 0;
    $this->color = 0;
    $this->inverse = 0;
    $this->inverter = 0;
    $this->inverseascii = 0;
    $this->color_background = "ffffff";
    $this->color_font = "000000";
    $this->letter_types = array(1, 2, 3, 4);
    $this->chars = "";
    $this->nodispersion = 0;
    $this->antialias = 0;
    $this->fontsize = 13;
    $this->size = $this->get_size();
    $this->write = "";
    $this->towrite = array();
    $this->writepts = array();
    $this->writemin = 0;
    $this->writemax = 0;
    $this->where = "";
    $this->px = 8;
    $this->py = 13;
    $this->letterspacing = 0;
    $this->lignheight = 0;
    $this->t = 0;
    $this->fh = 0;
    $this->fv = 0;
    $this->color_font2 = "";
    $this->p_two_colored = 0.5;
    $this->median=0;
    $this->lastfontcolor = "b";
		$this->styletag = 1;
  }
  
  function convert($image, $showStyleTag = 1)      
  // 1. Attribute: location of a valid image 
  {
    // Preconditions
    if ($this->px <= 0)
      die ('Cell width may not be smaller than 0');
    if ($this->py <= 0)
      die ('Cell height may not be smaller than 0'); 
    
    
		$this->styletag = $showStyleTag;
		
    // Image Conversion
    $img = new image_color($image);
    list($width, $height) = getimagesize($image);
    
    if ($this->type == 2){          // if in ASCII mode
      $this->where = $this->get_where();  // get where clause for SQL query
      $this->size = $this->get_size();    // get the size of font, for the database
      $white = mysql_query("SELECT ".$this->size." FROM ascii WHERE ".$this->where." ORDER BY ".$this->size." ASC LIMIT 1");
      list($white) = mysql_fetch_row($white) or die(mysql_error());   // minimum
      $black = mysql_query("SELECT ".$this->size." FROM ascii WHERE ".$this->where." ORDER BY ".$this->size." DESC LIMIT 1");
      list($black) = mysql_fetch_row($black) or die(mysql_error());   // maximum
      srand((double)microtime() * 10000000);    // initialize RNG (random number generator)
      $this->set_type(2);           // set px and py to correct value
      
      if ($this->color_font2 && !$this->color) // two colored fonts mode, set median
        $this->median = ($black-$white)*$this->p_two_colored + $white;
    }
    
    $result = $this->opening_tag;
    $this->lastspan = "c";
    for ($y=0; $y<$height;$y+=$this->py) {
      $result .= $this->newline_tag;
      for ($x=0; $x<$width; $x+=$this->px) {
      
        if ($this->fh){ // flip horizontally
          $tx = ($width-$x-$this->px < 0)?0:$width-$x-$this->px;
          $till_x = $width-$x-1;
        }
        else{           // don't flip horizontally
          $tx = $x;
          $till_x = ($tx+$this->px > $width)?$width-1:$tx-1+$this->px;
        }
        
        if ($this->fv){ // flip vertically
          $ty = ($height-$y-$this->py < 0)?0:$height-$y-$this->py;
          $till_y = $height-$y-1;
        }
        else{           // don't flip vertically
          $ty = $y;
          $till_y = ($ty+$this->py > $height)?$height-1:$ty-1+$this->py;
        }
        
        $color = $img->get_color_at_pos($tx, $ty, $till_x, $till_y, $this->antialias);
        
        // if no color is used -> black and white
        if ($this->color == 0){ 
          $color['red'] = ($color['red'] + $color['green'] + $color['blue'])/3;
          $color['green'] = $color['red'];
          $color['blue'] = $color['red'];
        }
        $result .= $this->get_output($color, $white, $black);
      }
      $result .= $this->endline_tag;
    }
    $result .= $this->closing_tag;
    $this->output_ok = 1;
    return($result);
  }
  
  function set_type($type)
  {
    // Precondition
    if ($type != 1 && $type != 2)
      die ('the type "'.$type.'" is invalid');
    
    $this->type = $type;
    if ($this->type == 1){          // if Table output
      $this->opening_tag = '<table border="0" cellspacing="0" cellpadding="0">';
      $this->closing_tag = "\n</table>";
      $this->newline_tag = "\n<tr>\n";
      $this->endline_tag = '</tr>';
    }
    elseif ($this->type == 2){      // if ASCII output
			if ($this->styletag == 1)
			{
	      $this->opening_tag = '<style type="text/css">'."\n";
	      $this->opening_tag .= '.courier{font-family: ';
	      $this->opening_tag .= ($this->fontsize>8)?'courier':'courier new';
	      $this->opening_tag .= ';font-size: '.$this->fontsize.'; line-height: ';
	      $this->opening_tag .= $this->py.'px; letter-spacing: '.$this->letterspacing.'px;';
	      $this->opening_tag .= 'color: #'.$this->color_font.';}'."\n";
	      
	      // if 6 is contained in art -> set inverter
	      for ($i=0; $i<count ($this->letter_types); $i++) {
	        if ($this->letter_types[$i] == 6)
	          $this->inverter = 1;
	      }
	      if ($this->inverter)  
	      {
	        $this->opening_tag .= '.inverse{font-family: ';
	        $this->opening_tag .= ($this->fontsize>8)?'courier':'courier new';
	        $this->opening_tag .= ';font-size: '.$this->fontsize.'; line-height: ';
	        $this->opening_tag .= $this->py.'px; letter-spacing: '.$this->letterspacing.'px;';
	        $this->opening_tag .= 'color: #'.$this->color_background.'; background-color: #'.$this->color_font.'}';
	      }
	      else
	        $this->inverter = 0;
	      
	      if ($this->color_font2 && !$this->color)  // if two-color mode is used
	      {
	        $this->opening_tag .= '.courier_color2{font-family: ';
	        $this->opening_tag .= ($this->fontsize>8)?'courier':'courier new';
	        $this->opening_tag .= ';font-size: '.$this->fontsize.'; line-height: ';
	        $this->opening_tag .= $this->py.'px; letter-spacing: '.$this->letterspacing.'px;';
	        $this->opening_tag .= 'color: #'.$this->color_font2.';}'."\n";
	      }
	      
	      $this->opening_tag .= '</style>';
			}
			else
			{
				$this->opening_tag = "";
			}
			
			$this->opening_tag .= "\n\n".'<nobr><span class="courier">';
      $this->closing_tag = '</span></nobr>';
      $this->newline_tag = '';
      $this->endline_tag = "<br />\n";
    }
  }
  
  // Returns needed output for a given color
  function get_output($color, $white, $black)
  {
    if ($this->type == 1){          // if Table output
      if ($this->inverse)
        $hex = sprintf("%02x%02x%02x", 255-$color['red'], 255-$color['green'], 255-$color['blue']);
      else
        $hex = sprintf("%02x%02x%02x", $color['red'], $color['green'], $color['blue']);
      $result = '<td width="'.$this->px.'" height="'.$this->py.'" bgcolor="#'.$hex.'"></td>'."\n";
    }
    elseif ($this->type == 2){      // if ASCII output
      if (!$this->write){           // normal character
        if ($this->color_font2 && !$this->color) // two colored fonts mode
        {
          $farbe = ($color['red'] + $color['green'] + $color['blue'])/3; // darkness
          if ($farbe/255 > $this->p_two_colored) {
            $darkness = 255-($farbe-255*$this->p_two_colored)/(1-$this->p_two_colored);
            $color['red'] = $darkness;
            $color['green'] = $darkness;
            $color['blue'] = $darkness;
            if ($this->lastfontcolor == "b" || $this->lastfontcolor == "b1")
              $this->lastfontcolor = "w1";  // start <span>
            else
              $this->lastfontcolor = "w";
            $result .= $this->get_char($color, $white, $black); } // light letters
          else {
            $darkness = $farbe/$this->p_two_colored;
            $color['red'] = $darkness;
            $color['green'] = $darkness;
            $color['blue'] = $darkness;
            if ($this->lastfontcolor == "w" || $this->lastfontcolor == "w1")
              $this->lastfontcolor = "b1";  // start <span>
            else
              $this->lastfontcolor = "b";
            $result .= $this->get_char($color, $white, $black);  // dark letters
          }
        }
        else
        {
          $result .= $this->get_char($color, $white, $black);
        }
      }
      else {                                // 'write' mode (word_repeater)
        $rand = rand()/(getrandmax()+1);    // random value between 0 an 1
        $g = $this->t%count($this->towrite);
        $farbe = ($color['red'] + $color['green'] + $color['blue'])/3;
        if ($this->writemax==0)
          $this->writemax = 0.001;
        if ($farbe/255*$this->writepts[$g]/$this->writemax <= $rand || $this->color)
          $result .= $this->towrite[$g];
        else
          $result .= "&nbsp;";
        $this->t++;
      }
    }
    return($result);
  }
  
  // Returns Character
  function get_char($color, $white, $black)
  {
    $farbe = ($color['red'] + $color['green'] + $color['blue'])/3; // darkness
    $val = $farbe*($black-$white)/255+$white;
    if (!$this->inverseascii)
      $val = $black+$white-$val;
    
    // no dispersion
    if ($this->nodispersion)
    {
      $query = mysql_query("SELECT charid, achar FROM ascii WHERE (".$this->where.") ORDER BY abs($val-".$this->size.") ASC LIMIT 1");
      $row = mysql_fetch_row($query) or die("000: ".mysql_error());
      $char_id = $row[0];
      $achar = $row[1];
    }
    
    // normal dispersion
    else
    {
      // get the next upper and next lower characters in database, for later random distribution
      $result_upper = mysql_query("SELECT id, ".$this->size." FROM ascii WHERE (".$this->where.") && ".$this->size." >= ".$val." ORDER BY ".$this->size." ASC LIMIT ".$this->depth);
      $result_lower = mysql_query("SELECT id, ".$this->size." FROM ascii WHERE (".$this->where.") && ".$this->size." < ".$val." ORDER BY ".$this->size." DESC LIMIT ".$this->depth);
      $array_ids_upper = array();
      $array_ids_lower = array();
      
      // Upper
      $i = 0;
      while ($row = mysql_fetch_row($result_upper))
      {
        $i++;
        if ($i==1){                                       // First found element is pushed on array
          array_push($array_ids_upper,$row[0]);
          $dist_upper = $row[1] - $val;
          }
        elseif ($row[1]-$val==$dist_upper){              // All others with same value are also pushed
          array_push($array_ids_upper,$row[0]);
          }
        else
          break;
      }
      
      // Lower
      $i = 0;
      while ($row = mysql_fetch_row($result_lower))
      {
        $i++;
        if ($i==1){                                       // First found element is pushed on array
          array_push($array_ids_lower,$row[0]);
          $dist_lower =  $val - $row[1];
          }
        elseif ($val - $row[1]==$dist_lower){             // All others with same value are also pushed
          array_push($array_ids_lower,$row[0]);
          }
        else
          break;
      }

      $rand = rand()/(getrandmax()+1);
      
      if ($rand*($dist_lower+$dist_upper) < $dist_upper && count($array_ids_lower) > 0) // lower character is chosen
        $char_id = $array_ids_lower[floor($rand*count($array_ids_lower))];
      elseif (count($array_ids_upper) > 0)                                                  // higher character is chosen
        $char_id = $array_ids_upper[floor($rand*count($array_ids_upper))];
      else 
        $char_id = $array_ids_lower[floor($rand*count($array_ids_lower))];
      
      $query = mysql_query("SELECT type, achar, charid FROM ascii WHERE id='".$char_id."' LIMIT 1");
      $row3 = mysql_fetch_row($query) or die("error 001: ".mysql_error());
      $achar = $row3[1];
      $char_id = $row3[2];
    }
    
    // Further settings after Character is fetched
    
    if ($row3[0] == 6)  // if type == 6
    {
      if ($this->lastspan == "c")
      {
        $result .= "</span><span class=\"inverse\">";
        $this->lastspan = "i";
      }
    }
    elseif ($this->lastspan=="i")
    {
      $result .= "</span><span class=\"courier\">";
      $this->lastspan = "c";
    }
    
    if ($this->color_font2 && !$this->color) // two colored fonts mode, set span.
    {
      if ($this->lastfontcolor == "b1")
        $result .= "</span><span class=\"courier\">";
      elseif ($this->lastfontcolor == "w1")
        $result .= "</span><span class=\"courier_color2\">";
    }
    
    if ($this->color)
    {
      if ($this->inverse)
      {
        $hex = sprintf("%02x%02x%02x",255-$color['red'],255-$color['green'],255-$color['blue']);
      }
      else
      {
        $hex = sprintf("%02x%02x%02x", $color['red'], $color['green'], $color['blue']);
      }
      $result .= "<font color=\"#".$hex."\">";
    }
      
    if ($char_id==32 || $char_id==287)
      $result .=  "&nbsp;";
    elseif ($this->htmlencoded)
      $result .=  "&#".$char_id.";";
    else
      $result .=  $achar;
    
    if ($this->color)
      $text.=  "</font>";
    return($result);
  }
  
  // returns size for the database
  function get_size()
  {
    switch ($this->fontsize) {
      case 13 :  $result = 'c13'; break;
      case 16 :  $result = 'c16'; break;
      default  : $result = 'c20'; break;
    }
    return($result);
  }
  
  // returns mySQL query for fetching characters
  function get_where()
  {
    if (!$this->unicode && !$this->chars)            // if ANSI characters only
    {
      $result .= 'charid <= 256 AND (';
    }
    
    if ($this->chars)
    {
      $result .= "(";
			
	    $g=0;
	    for ($i=0;$i<strlen($this->chars);$i++)
	    {
	      $char = $this->chars[$i];
	      if ($char=="&")
	      {
	        $pos = strpos($this->chars,";",$i);
	        if ($pos)
	        {
	          $char="";
	          for ($j=$i;$j<=$pos;$j++)
	            $char .= $this->chars[$j];
	          $i=$j;
	        }
	      }
	      $asciichars[$g] = $char;
	      $g++;
	    } // end foreach
			
      foreach ($asciichars as $char)
      { 
        $result .= " achar='";
        switch ($char) {
          case "&" :  $result .= '&amp;'; break;
          case " " :  $result .= '&nbsp;'; break;
          case "<" :  $result .= '&lt;'; break;
          case ">" :  $result .= '&gt;'; break;
          default  :  $result .= $char; break;
        }
        $result .= "' ||";
      }
			
      $result = substr($result,0,-3);
			$result .= ") && (id < 1139) ||";
      // if (!$this->inverter)
      //  $result .= ")  ||"; // this is done so no special characters are fetched, like  instead of u
      // else
      //   $result .= ") && (id < 192 || (id > 1138 && id < 1261)) ||";
    }
		elseif (count($this->letter_types)>0)  // if character from select list is selected, in addition then the chars below
    {      
      foreach ($this->letter_types as $temp)
      {
        if ($this->inverter && $temp != 6) // inverse characters (bg-fg)
          $result .= " type='".$temp."' || type='6|".$temp."' ||";
        elseif ($temp != 6)
          $result .= " type='".$temp."' ||";   
      }
    }
    
    $result = substr($result,0,-3);
    
    if ($this->letter_types[0]==6 && !$this->chars) // blank letter inversed - only "inversed" was selected as a letter type
    {
      $result = "achar='&nbsp;'";
    }
    if (!$this->unicode && !$this->chars) 
    {
      $result .= ")";
    }
    return($result);
  }
  
  function set_use_write_mode($word)
  {
    // only set to this mode if word contains something
    if (!empty($word))
    {
      $this->write = $word;
      $g=0;
      for ($i=0;$i<strlen($word);$i++)
      {
        $char = $word[$i];
        if ($char=="&")
        {
          $pos = strpos($word,";",$i);
          if ($pos)
          {
            $char="";
            for ($j=$i;$j<=$pos;$j++)
              $char.=$word[$j];
            $i=$j;
          }
     }
        $this->towrite[$g] =  $char;
        $id = substr($char,1,-1);
        $result = mysql_query("SELECT ".$this->size." FROM ascii WHERE (achar='$char' || id='$id') && type!='6'");
        list($this->writepts[$g]) = mysql_fetch_row($result) or die("002: ".mysql_error());   // result
        if ($g==1)  // first entry
        {
          $this->writemin = $this->writepts[1];
          $this->writemax = $this->writepts[1];
        }
        elseif ($this->writepts[$g] < $this->writemin)
          $this->writemin = $this->writepts[$g];
        elseif ($this->writepts[$g] > $this->writemax)
          $this->writemax = $this->writepts[$g];
        $g++;
      }
    }  
  }
  
  // Resets step sizes (px, py) according to font size, lignheight and letterspacing
  function reset_step()
  {
    switch ($this->fontsize) {
      case 4:
        $this->px = 2+$this->letterspacing;
        $this->py = 4+$this->lignheight;
        // when printed $px should be 2.5+$letterspacing, otherwise it should be 2 (for the screen)
        break;
      case 6:
        $this->px = 4+$this->letterspacing;
        $this->py = 7+$this->lignheight;
        break;
      case 8:
        $this->px = 5+$this->letterspacing;
        $this->py = 8+$this->lignheight;
        break;
      case 16:
        $this->px = 9+$this->letterspacing;
        $this->py = 16+$this->lignheight;
        break;
      case 20:
        $this->px = 12+$this->letterspacing;
        $this->py = 20+$this->lignheight;
        break;
      default:
        $this->px = 8+$this->letterspacing;
        $this->py = 13+$this->lignheight;
        break;
    }
  }
  
  function set_fontsize($fontsize)
  {
    $this->fontsize = $fontsize;
    $this->reset_step();
  }
  
  function set_two_fontcolors($c1, $bg, $c2, $p)
  {
    // Precondition
    if ($p > 1)
      die ('the percentage may not be larger than 1');
    
    $this->color = 0;                 // color functionality is removed
    $this->color_font = $c1;          // dark
    $this->color_background = $bg;    // medium
    $this->color_font2 = $c2;         // light
    $this->p_two_colored = $p;        // normally around 0.5
  }
  
  /****************************************************************************************/
  /*                                 Predefined Modes                                     */  
  /****************************************************************************************/
  
  function set_mode($mode)
  {
    switch ($mode) {
    
      // Black and White dots mode, with other browsers than Internet Explorer the dots
      // might be grayish due to antialiasing. The image is displayed with dots '.' and 
      // blanks ' '.
      case "blacknwhite":
        $this->img2ascii(); // set back to default
        $this->set_use_write_mode(".");
        $this->type = 2;
        $this->fontsize = 8;
        $this->lignheight = -7;
        $this->letterspacing = -4;
        $this->reset_step();
        break;
      
      default: 
        break;
    }
  } 
}

// Returns the IMG2ASCII version
if (isset($_GET['version'])){
  $v = new img2ascii();
  echo $v->version;
  exit;
}
?>