<?php
/******************************************************************************************/
/*                                 IMG2ASCII - Image Class                                */  
/******************************************************************************************/
/*
    IMG2ASCII version 2 Beta
    
    Copyright 2003 by Ueli Weiss (uweiss@gmx.ch)
    
    This program is free software; you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation. This program is distributed in the hope 
    that it will be useful, but WITHOUT ANY WARRANTY; without even the 
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
    See the GNU General Public License for more details.
    
    This copyright text may not be edited or deleted.
    
    Best quality is achieved with font size 13 - 20 (since there is no 
    anti-aliasing, which would make the image too light). Scaling the image 
    down afterwards in an image manipulation program leads to better results.
    
    You may use generated images on your websites, or wherever you like, but 
    if you do, please add a link to http://www.3d-community.com/ascii/ as a 
    return service. Thanks!
    
    Have fun!
                                                                                          */
/******************************************************************************************/

class image_color
{
  var $width, $height, $img;
  
  // constructor, initialization
  function image_color($image)
  {
    $size = getimagesize($image);
    if ($size[2] == 2)      // jpeg
      $this->img = imagecreatefromjpeg($image) or die('image could not be read');
    elseif ($size[2] == 3)  // png
      $this->img = imagecreatefrompng($image) or die('image could not be read');
    else
      die('The type of the provided file is not valid');
    $this->width = $size[0];
    $this->height = $size[1];
  }
  
  // returns color values as an RGB array between 0 and 255
  function get_color_at_pos($x1, $y1, $x2, $y2, $antialias)
  {    
    if (!$antialias)
    {
      $rgb = ImageColorAt($this->img, $x1, $y1);
      $color = imagecolorsforindex($this->img, $rgb);
    }
    else // Antialiasing
    {
      // Precondition
      if ($x2-$x1 < 0)
        die ('Invalid arguments for get_color_at_pos().<br />x1: '.$x1.'<br />x2: '.$x2);
      if ($y2-$y1 < 0)
        die ('Invalid arguments for get_color_at_pos().<br />y1: '.$y1.'<br />y2: '.$y2);
      
      // loop through all pixels and get average
      $r=0; $g=0; $b=0;
      for ($j=$y1; $j<=$y2; $j++){
        for ($i=$x1; $i<=$x2; $i++){
          $rgb = ImageColorAt($this->img, $i, $j);
          $color = imagecolorsforindex($this->img, $rgb);
          $r += $color['red'];
          $g += $color['green'];
          $b += $color['blue'];
        }
      }
      $pixels = ($y2-$y1+1)*($x2-$x1+1);
      $color['red']   = $r / $pixels;
      $color['green'] = $g / $pixels;
      $color['blue']  = $b / $pixels;
    }
    return($color);
  }
}
?>